<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
package ${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.service.impl;

import ${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.domain.${item.codeName};
import ${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.service.${item.codeName}Service;
import ${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.dao.${item.codeName}Dao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.lang.reflect.Field;
import java.util.*;

/**
 * 实体[${item.codeName}] 服务对象接口实现
 */
@Transactional
@Service
public class ${item.codeName}ServiceImpl implements ${item.codeName}Service{

    @Autowired
    private ${item.codeName}Dao ${item.codeName?lower_case}dao;

    @PersistenceContext
    EntityManager entityManager;

    public void add${item.codeName} (${item.codeName} ${item.codeName?lower_case}){
        ${item.codeName?lower_case}dao.save(${item.codeName?lower_case});
    }
    public void delete${item.codeName} (${item.codeName} ${item.codeName?lower_case}){
        ${item.codeName?lower_case}dao.delete(${item.codeName?lower_case});
    }
    public void update${item.codeName} (${item.codeName} ${item.codeName?lower_case}){
        ${item.codeName?lower_case}dao.save(${item.codeName?lower_case});
    }
    public List<${item.codeName}> select${item.codeName}all (){
        return ${item.codeName?lower_case}dao.findAll();
    }
    public ${item.codeName} select${item.codeName} (String id){
        return ${item.codeName?lower_case}dao.findById(id).get();
    }

<#list item.getPSDEFields() as defield>
	<#list defield.getAllPSDEFSearchModes() as formitem>
	<#assign Entity_cap_first = formitem.getPSDEField().getName()?lower_case>
	<#if formitem.getValueOp() == "LIKE">
	<#comment>LIKE</#comment>
    public List<${item.codeName}> findBy${Entity_cap_first?cap_first}Containing(String param){
        return ${item.codeName?lower_case}dao.findBy${Entity_cap_first?cap_first}Containing(param);
    }
    <#elseif formitem.getValueOp() == "LEFTLIKE">
    <#comment>LEFTLIKE</#comment>
    public List<${item.codeName}> findBy${Entity_cap_first?cap_first}StartingWith(String param){
        return ${item.codeName?lower_case}dao.findBy${Entity_cap_first?cap_first}StartingWith(param);
    }
    <#elseif formitem.getValueOp() == "RIGHTLIKE">
    <#comment>RIGHTLIKE</#comment>
    public List<${item.codeName}> findBy${Entity_cap_first?cap_first}EndingWith(String param){
        return ${item.codeName?lower_case}dao.findBy${Entity_cap_first?cap_first}EndingWith(param);
    }
    <#elseif formitem.getValueOp() == "EQ">
    <#comment>EQ</#comment>
    public List<${item.codeName}> findBy${Entity_cap_first?cap_first}(String param){
        return ${item.codeName?lower_case}dao.findBy${Entity_cap_first?cap_first}(param);
    }
    <#elseif formitem.getValueOp() == "NOTEQ">
    <#comment>NOTEQ</#comment>
    public List<${item.codeName}> findBy${Entity_cap_first?cap_first}Not(String param){
        return ${item.codeName?lower_case}dao.findBy${Entity_cap_first?cap_first}Not(param);
    }
    <#elseif formitem.getValueOp() == "GT">
    <#comment>GT</#comment>
    public List<${item.codeName}> findBy${Entity_cap_first?cap_first}GreaterThan(String param){
        return ${item.codeName?lower_case}dao.findBy${Entity_cap_first?cap_first}GreaterThan(param);
    }
    <#elseif formitem.getValueOp() == "GTANDEQ">
    <#comment>GTANDEQ</#comment>
    public List<${item.codeName}> findBy${Entity_cap_first?cap_first}GreaterThanEqual(String param){
        return ${item.codeName?lower_case}dao.findBy${Entity_cap_first?cap_first}GreaterThanEqual(param);
    }
    <#elseif formitem.getValueOp() == "LT">
    <#comment>LT</#comment>
    public List<${item.codeName}> findBy${Entity_cap_first?cap_first}LessThan(String param){
        return ${item.codeName?lower_case}dao.findBy${Entity_cap_first?cap_first}LessThan(param);
    }
    <#elseif formitem.getValueOp() == "LTANDEQ">
    <#comment>LTANDEQ</#comment>
    public List<${item.codeName}> findBy${Entity_cap_first?cap_first}LessThanEqual(String param){
        return ${item.codeName?lower_case}dao.findBy${Entity_cap_first?cap_first}LessThanEqual(param);
    }
    </#if>

	</#list>
</#list>

    public List<${item.codeName}> Qbc(${item.codeName} ${item.codeName?lower_case}){

        String str = "SELECT t FROM ${item.getTableName()} t";
        StringBuffer condition = new StringBuffer();
        String str_if = "";
<#list item.getPSDEFields() as defield>
	<#list defield.getAllPSDEFSearchModes() as formitem>
        <#assign Entity_cap_first = formitem.getPSDEField().getName()?lower_case>
        <#if formitem.getValueOp() == "LIKE">
        <#comment>LIKE</#comment>
        if(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()!=null&&!"".equals(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}())){
            condition.append(" and ").append(" t.${Entity_cap_first} ").append(" like ").append("'").append("%").append(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()).append("%").append("'");
        }
        <#elseif formitem.getValueOp() == "LEFTLIKE">
        <#comment>LEFTLIKE</#comment>
        if(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()!=null&&!"".equals(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}())){
            condition.append(" and ").append(" t.${Entity_cap_first} ").append(" like ").append("'").append(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()).append("%").append("'");
        }
        <#elseif formitem.getValueOp() == "RIGHTLIKE">
        <#comment>RIGHTLIKE</#comment>
        if(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()!=null&&!"".equals(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}())){
            condition.append(" and ").append(" t.${Entity_cap_first} ").append(" like ").append("'").append("%").append(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()).append("'");
        }
        <#elseif formitem.getValueOp() == "EQ">
        <#comment>EQ</#comment>
        if(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()!=null&&!"".equals(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}())){
            condition.append(" and ").append(" t.${Entity_cap_first} ").append(" = ").append("'").append(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()).append("'");
        }
        <#elseif formitem.getValueOp() == "NOTEQ">
        <#comment>NOTEQ</#comment>
        if(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()!=null&&!"".equals(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}())){
            condition.append(" and ").append(" t.${Entity_cap_first} ").append(" != ").append("'").append(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()).append("'");
        }
        <#elseif formitem.getValueOp() == "GT">
        <#comment>GT</#comment>
        if(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()!=null&&!"".equals(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}())){
            condition.append(" and ").append(" t.${Entity_cap_first} ").append(" > ").append("'").append(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()).append("'");
        }
        <#elseif formitem.getValueOp() == "GTANDEQ">
        <#comment>GTANDEQ</#comment>
        if(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()!=null&&!"".equals(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}())){
            condition.append(" and ").append(" t.${Entity_cap_first} ").append(" >= ").append("'").append(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()).append("'");
        }
        <#elseif formitem.getValueOp() == "LT">
        <#comment>LT</#comment>
        if(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()!=null&&!"".equals(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}())){
            condition.append(" and ").append(" t.${Entity_cap_first} ").append(" < ").append("'").append(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()).append("'");
        }
        <#elseif formitem.getValueOp() == "LTANDEQ">
        <#comment>LTANDEQ</#comment>
        if(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()!=null&&!"".equals(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}())){
            condition.append(" and ").append(" t.${Entity_cap_first} ").append(" <= ").append("'").append(${item.codeName?lower_case}.get${Entity_cap_first?cap_first}()).append("'");
        }
        </#if>
	</#list>
</#list>
        if(condition.length()>0){
            str_if = condition.toString();
            str_if = str_if.substring(4,str_if.length());
            str = str+" where "+str_if;
        }
        Query query = entityManager.createQuery(str);
        List<${item.codeName}> persons = query.getResultList();
        return persons;
    }

}